searchData={"items":[{"type":"extras","title":"Generic A64-OLinuXino Support","doc":"# Generic A64-OLinuXino Support\n\n[![CircleCI](https://circleci.com/gh/pavels/nerves_system_a64_olinuxino.svg?style=svg)](https://circleci.com/gh/pavels/nerves_system_a64_olinuxino)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_system_a64_olinuxino.svg \"Hex version\")](https://hex.pm/packages/nerves_system_a64_olinuxino)\n\nThis is the base Nerves System configuration for the [A64-OLinuXino](https://www.olimex.com/Products/OLinuXino/A64/A64-OLinuXino)\n\n![A64-OLinuXino image](assets/images/A64-OLinuXino-.jpg)\n\n| Feature              | Description                     |\n| -------------------- | ------------------------------- |\n| CPU                  | Allwinner A64 - 1.2 GHz Quad-Core ARM Cortex-A53 64-bit             |\n| Memory               | 1GB or 2GB RAM DDR3L @ 672Mhz   |\n| Storage              | MicroSD (eMMC not supported)    |\n| Linux kernel         | 5.2 mainline                    |\n| IEx terminal         | UART `ttyS0`                    |\n| GPIO, I2C, SPI       | Yes, I2C and SPI on UEXT        |\n| ADC                  | No                              |\n| PWM                  | No                              |\n| UART                 | ttyS0 + ttyS2 on UEXT           |\n| Camera               | None                            |\n| Ethernet             | Yes                             |\n| WiFi                 | RTL8723BS on board (some board configurations). Other requires USB WiFi dongle/driver |\n| HW Watchdog          | sunxi watchdog available        |\n| Power Management     | AXP803 driver available - support for battery and ac charger status        |","ref":"readme.html"},{"type":"extras","title":"Using - Generic A64-OLinuXino Support","doc":"The most common way of using this Nerves System is create a project with `mix\nnerves.new` and to export `MIX_TARGET=a64_olinuxino`. See the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/systems.html#customizing-your-own-nerves-system)\n\nIf you're new to Nerves, check out the\n[nerves_init_gadget](https://github.com/nerves-project/nerves_init_gadget)\nproject for creating a starter project. It will get you started with the basics\nlike bringing up networking, initializing the writable application data\npartition, and enabling ssh-based firmware updates.  It's easiest to begin by\nusing the wired Ethernet interface 'eth0' and DHCP.","ref":"readme.html#using"},{"type":"extras","title":"Console access - Generic A64-OLinuXino Support","doc":"The console is configured to output to the 6 pin header on the\nA64-OLinuXino that's labeled `DBG_UART`. A 3.3V FTDI cable is needed to access the output.","ref":"readme.html#console-access"},{"type":"extras","title":"Provisioning devices - Generic A64-OLinuXino Support","doc":"This system supports storing provisioning information in a small key-value store\noutside of any filesystem. Provisioning is an optional step and reasonable\ndefaults are provided if this is missing.\n\nProvisioning information can be queried using the Nerves.Runtime KV store's\n[`Nerves.Runtime.KV.get/1`](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.KV.html#get/1)\nfunction.\n\nKeys used by this system are:\n\nKey                    | Example Value     | Description\n:--------------------- | :---------------- | :----------\n`nerves_serial_number` | `\"12345678\"`      | By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Etherner MAC Address.\n\nThe normal procedure would be to set these keys once in manufacturing or before\ndeployment and then leave them alone.\n\nFor example, to provision a serial number on a running device, run the following\nand reboot:\n\n```elixir\niex> cmd(\"fw_setenv nerves_serial_number 12345678\")\n```\n\nThis system supports setting the serial number offline. To do this, set the\n`NERVES_SERIAL_NUMBER` environment variable when burning the firmware. If you're\nprogramming MicroSD cards using `fwup`, the commandline is:\n\n```sh\nsudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw\n```\n\nSerial numbers are stored on the MicroSD card so if the MicroSD card is\nreplaced, the serial number will need to be reprogrammed. The numbers are stored\nin a U-boot environment block. This is a special region that is separate from\nthe application partition so reformatting the application partition will not\nlose the serial number or any other data stored in this block.\n\nAdditional key value pairs can be provisioned by overriding the default provisioning.conf\nfile location by setting the environment variable\n`NERVES_PROVISIONING=/path/to/provisioning.conf`. The default provisioning.conf\nwill set the `nerves_serial_number`, if you override the location to this file,\nyou will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"UEXT - Generic A64-OLinuXino Support","doc":"All parts of `UEXT` port are enabled and supported.\n\nSPI is on `spidev0.0`\n\nI2c is on `i2c-0`\n\nUART is on `ttyS1`","ref":"readme.html#uext"},{"type":"extras","title":"GPIO - Generic A64-OLinuXino Support","doc":"For GPIO access use [circuits_cdev](https://github.com/elixir-circuits/circuits_cdev).\n\nAll GPIOs are on `gpiochip2`.\n\nUse following formula to calculate proper GPIO number from pin name (like PE0):\n\n```\n(position of letter in alphabet - 1) * 32 + pin number\n```\n\n> For `PE0` this would be '`4 * 32 + 0 = 128`'","ref":"readme.html#gpio"},{"type":"extras","title":"SPI - Generic A64-OLinuXino Support","doc":"If you have included [circuits_spi](https://github.com/elixir-circuits/circuits_spi) as a\ndependency, you can start it now and test a transfer:\n\n> The example below should work without any additional hardware connected to the\n> OLinuXino. If you have SPI hardware connected to the OLinuXino, your returned binary might\n> be different.\n\n```elixir\niex> {:ok, ref} = Circuits.SPI.open(\"spidev0.0\")\n{:ok, #Reference<...>}\niex> Circuits.SPI.transfer(ref, <<1,2,3,4>>)\n<<0, 0, 0, 0>>\n```","ref":"readme.html#spi"},{"type":"extras","title":"I2C - Generic A64-OLinuXino Support","doc":"If you have included [circuits_i2c](https://github.com/elixir-circuits/circuits_i2c) as a\ndependency, you can use it to scan for devices:\n\n```elixir\niex> Circuits.I2C.detect_devices()\nDevices on I2C bus \"i2c-0\":\n```","ref":"readme.html#i2c"},{"type":"extras","title":"Audio - Generic A64-OLinuXino Support","doc":"Onboard audio input and output is supported and is set as default in ALSA.\n\nTo use it, you first need to enable it.\n\nTo enable output execute:\n\n```elixir\nSystem.cmd(\"amixer\", [\"-q\", \"sset\", \"AIF1 Slot 0 Digital DAC\", \"on\"])\nSystem.cmd(\"amixer\", [\"-q\", \"sset\", \"Headphone\", \"100%\", \"on\"])\n```\n\nTo enable microphone input execute\n\n```elixir\nSystem.cmd(\"amixer\", [\"-q\", \"sset\", \"AIF1 Data Digital ADC\", \"cap\", \"on\"])\nSystem.cmd(\"amixer\", [\"-q\", \"sset\", \"Mic1\", \"43%\", \"cap\", \"on\"])\n```","ref":"readme.html#audio"},{"type":"extras","title":"Supported WiFi devices - Generic A64-OLinuXino Support","doc":"Some boards has built in RTL8723BS. This module is not always very reliable and the signal strength is problematic due to on board antenna design.\n\nVarious USB WIFI dongle are supported. Recommended and tested ones are USB adapters supported by `rt2800usb` driver (Ralink RT2070, RT2770, RT2870, RT3070, RT3071, RT3072, RT3370, RT3572, RT5370, RT5372, RT5572).","ref":"readme.html#supported-wifi-devices"},{"type":"extras","title":"Installation - Generic A64-OLinuXino Support","doc":"If you're new to Nerves, check out the\n[nerves_init_gadget](https://github.com/fhunleth/nerves_init_gadget) project for\ncreating a starter project for the A64-OLinuXino boards.\n\nIt will get you started with the basics like bringing up the virtual Ethernet interface, initializing the application partition, and enabling ssh-based firmware updates.","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v1.2.1 - Changelog","doc":"* Expand CMA size so it is possible to use GPU and HW Video Decoder","ref":"changelog.html#v1-2-1"},{"type":"extras","title":"v1.2.0 - Changelog","doc":"* Upgraded kernel to 6.6.29\n* Upgraded buildroot to 2024.02.1\n* Upgraded nerves_system_br to 1.27.1\n* Fix thermal sensor","ref":"changelog.html#v1-2-0"},{"type":"extras","title":"v1.1.0 - Changelog","doc":"* Upgraded kernel to 5.15\n* Upgraded buildroot to 2022.11.3\n* Upgraded nerves_system_br to 1.22.5\n* Mainline U-Boot + Mainline Trusted Firmware\n* Cleaned up U-Boot configuration\n* Removed broken PWM module\n* Updated `README`","ref":"changelog.html#v1-1-0"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"* Initial release","ref":"changelog.html#v1-0-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}